---
- name: Install dependancies
  package: name={{item}} state=latest
  with_items:
    - python-openssl
    - acme-tiny
  tags:
    - ssl

- name: Generate an OpenSSL private key
  openssl_privatekey:
    path: "/etc/ssl/private/{{hostname}}.pem"
  tags:
    - ssl

- name: Directory for csr
  file:
    path: /etc/ssl/csr
    state: directory
    mode: 0755
  tags:
    - ssl

- name: CSR request
  openssl_csr:
    path: /etc/ssl/csr/{{hostname}}.csr
    privatekey_path: /etc/ssl/private/{{hostname}}.pem
    common_name: "{{hostname}}"
  tags:
    - ssl
- name: SSL chalanges path
  file:
    path: /etc/ssl/challenges/{{hostname}}/
    state: directory
    mode: 0755
  tags:
    - ssl


- name: Virtualhost config file
  template:
    src: virtualhost.conf
    dest: "/etc/apache2/sites-available/{{hostname}}.conf"
    owner: root
    mode: 0644
  become: yes
  tags:
    - init
    - virtualhost_config
- name: Config directory
  become: yes
  become_user: root
  file:
    path: /etc/apache2/sites-available/{{hostname}}
    state: directory
    mode: '0755'

- name: Enable virtualhost
  become: yes
  become_user: root
  command: /usr/sbin/a2ensite {{hostname}}
  args:
    creates: /etc/apache2/sites-enabled/{{hostname}}.conf
  notify: restart apache2